#! /bin/bash
############################################################################
##                                                                        ##
##     Copyright (C) 2010-2011  YannUbuntu (yannubuntu@gmail.com)         ##
##                                                                        ##
## This program is free software: you can redistribute it and/or modify   ##
## it under the terms of the GNU General Public License as published by   ##
## the Free Software Foundation, either version 3 of the License, or      ##
## (at your option) any later version.                                    ##
##                                                                        ##
## This program is distributed in the hope that it will be useful,        ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of         ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          ##
## GNU General Public License for more details.                           ##
##                                                                        ##
## You should have received a copy of the GNU General Public License      ##
## along with this program.  If not, see <http://www.gnu.org/licenses/>.  ##
##                                                                        ##
############################################################################
## Special thanks to Babdu89, Josepe36, and GRUB devs.
## LIBRAIRIES FOR OS-UNINSTALLER AND BOOT REPAIR
## http://ubuntuforums.org/showthread.php?t=1615667


################################### RESTORE MBR ###########################################
restore_mbr() {
DISK_TO_RESTORE_MBR="${MBR_TO_RESTORE%% (*}"
echo "Will restore the MBR_TO_RESTORE : $MBR_TO_RESTORE into $DISK_TO_RESTORE_MBR"
temp="${MBR_TO_RESTORE#* (}"; BETWEEN_PARENTHESIS="${temp%)*}"
echo "SET@_label0.set_text('''$Restore_MBR. $Please_wait''')"
if [[ -f $LOGREP/$DISK_TO_RESTORE_MBR/current_mbr.img ]];then	#Security
	cp $LOGREP/$DISK_TO_RESTORE_MBR/current_mbr.img $LOGREP/$DISK_TO_RESTORE_MBR/mbr_before_restoring_mbr.img
	if [[ "$MBR_TO_RESTORE" =~ generic ]];then
		install-mbr -e ${TARGET_PARTITION_FOR_MBR} /dev/${DISK_TO_RESTORE_MBR}; echo "install-mbr -e ${TARGET_PARTITION_FOR_MBR} /dev/${DISK_TO_RESTORE_MBR}"
	elif [[ "$BETWEEN_PARENTHESIS" =~ mbr ]] && [[ -f /usr/lib/syslinux/${BETWEEN_PARENTHESIS}.bin ]];then
		echo "dd if=/usr/lib/syslinux/${BETWEEN_PARENTHESIS}.bin of=/dev/${DISK_TO_RESTORE_MBR}"
		dd if=/usr/lib/syslinux/${BETWEEN_PARENTHESIS}.bin of=/dev/${DISK_TO_RESTORE_MBR} bs=446 count=1
		bootflag_action ${TARGET_PARTITION_FOR_MBR}
	else
		HBACKUP="mbr-$(cut -c-10 <<< "$BETWEEN_PARENTHESIS" )__$(cut -c12-13 <<< "$BETWEEN_PARENTHESIS" )h$(cut -c15-16 <<< "$BETWEEN_PARENTHESIS" )"
		DBACKUP="mbr-$(cut -c-10 <<< "$BETWEEN_PARENTHESIS" )__$(cut -c12-13 <<< "$BETWEEN_PARENTHESIS" ):$(cut -c15-16 <<< "$BETWEEN_PARENTHESIS" )"
		if [[ "$(ls "$LOGREP/${DISK_TO_RESTORE_MBR}/" )" =~ "$HBACKUP" ]]; then
			restore_mbr_backup_into_the_mbr $(ls "$LOGREP/${DISK_TO_RESTORE_MBR}/" | grep "$HBACKUP" ) ${DISK_TO_RESTORE_MBR}
		elif [[ "$(ls "$LOGREP/${DISK_TO_RESTORE_MBR}/" )" =~ "$DBACKUP" ]]; then
			restore_mbr_backup_into_the_mbr $(ls "$LOGREP/${DISK_TO_RESTORE_MBR}/" | grep "$DBACKUP" ) ${DISK_TO_RESTORE_MBR}
		else
			echo "Error : $MBR_TO_RESTORE [$BETWEEN_PARENTHESIS] could not be restored in $DISK_TO_RESTORE_MBR."
			ls "$LOGREP/${DISK_TO_RESTORE_MBR}/"
			zenity --error --text="Error : $MBR_TO_RESTORE could not be restored in $DISK_TO_RESTORE_MBR."
		fi
	fi
else
	echo "Error : $LOGREP/$DISK_TO_RESTORE_MBR/current_mbr.img does not exist"
	zenity --error --text="Error : $LOGREP/$DISK_TO_RESTORE_MBR/current_mbr.img does not exist. MBR could not be restored."
fi
}

# called by : restore_mbr
restore_mbr_backup_into_the_mbr() {
if [[ -f "$LOGREP/$2/$1" ]];then	#Security
	echo "Restore the Clean-Ubiquity MBR backup $1 into the MBR of disk $2"
	mv "$LOGREP/$2/current_mbr.img" "$LOGREP/$2/mbr_before_restoration.img"
	dd if="$LOGREP/$2/$1" of=/dev/$2 bs=446 count=1 #Stops before the partition table
else 
	echo "Error : $LOGREP/$2/$1 does not exist"
	zenity --error --text="Error : MBR backup $LOGREP/$2/$1 does not exist. MBR could not be restored."
fi
}


################################ REINSTALL GRUB ##################################################
reinstall_action() {
if [[ "$FORCE_GRUB" = "all" ]];then
	if [[ "$REMOVABLEDISK" = "yes" ]];then
		echo "REMOVABLEDISK is Yes, so we reinstall GRUB of the removable media only in its disk MBR"
		NOFORCE_DISK="${DISK_PART[$PART_TO_REINSTALL_GRUB]}"; reinstall_grub
		REMOVABLE_PART_TO_REINSTALL_GRUB="$PART_TO_REINSTALL_GRUB"
		PART_TO_REINSTALL_GRUB="none"
		for ((x=1;x<=QTY_OF_PART_WITH_GRUB;x++)); do
			if [[ "${DISK_PART[$REMOVABLE_PART_TO_REINSTALL_GRUB]}" != "${DISK_PART[${LIST_OF_PART_WITH_GRUB[$x]}]}" ]] \
			&& [[ "$PART_TO_REINSTALL_GRUB" = "none" ]] \
			&& [[ "${LISTOFPARTITIONS[${LIST_OF_PART_WITH_GRUB[$x]}]}" != "$OS_TO_DELETE_PARTITION" ]]; then
				PART_TO_REINSTALL_GRUB="${LIST_OF_PART_WITH_GRUB[$x]}"
				loop_install_grub_in_all_other_disks
			fi
		done
	else
		REMOVABLE_PART_TO_REINSTALL_GRUB=""
		loop_install_grub_in_all_other_disks
	fi
else
	reinstall_grub
fi
repair_boot_ini
}

loop_install_grub_in_all_other_disks() {
echo "Reinstall the GRUB of ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]} into all MBRs of disks with OS or not-USB"
for ((n=1;n<=NBOFDISKS;n++)); do
#	a=$(sudo parted -l /dev/${LISTOFDISKS[$n]} | grep ${LISTOFDISKS[$n]})
#	b=${a#*: }
#	DISKSIZE=${b%,*}
#	if [[ "$DISKSIZE" > "20" ]] 
	if [[ ! "$(ls -l /dev/disk/by-id | grep " usb-" | grep "${LISTOFDISKS[$n]}")" ]] || [[ "${DISK_WITHOS[$n]}" = "with-os" ]] \
	&& [[ "${LISTOFDISKS[$n]}" != "${DISK_PART[$REMOVABLE_PART_TO_REINSTALL_GRUB]}" ]];then
		NOFORCE_DISK="${LISTOFDISKS[$n]}"; reinstall_grub
	fi
done
}

reinstall_grub() {
if [[ "$FORCE_GRUB" = "yes" ]]; then 
	GRUBSTAGEONE="$FORCE_PARTITION"; echo "Reinstall the GRUB of ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]} into the $GRUBSTAGEONE partition"
	reinstall_grubstageone
else
	GRUBSTAGEONE="$NOFORCE_DISK"; echo "Reinstall the GRUB of ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]} into the MBR of $GRUBSTAGEONE"
	if [[ -f $LOGREP/$GRUBSTAGEONE/current_mbr.img ]];then	#Security
		reinstall_grubstageone
	else
		echo "Error : $LOGREP/$GRUBSTAGEONE/current_mbr.img does not exist"
		zenity --error --text="Error : $LOGREP/$GRUBSTAGEONE/current_mbr.img does not exist. GRUB could not be reinstalled."
	fi
fi
}

reinstall_grubstageone() {
force_unmount_os_partitions_in_mnt_except_reinstall_grub	#OS are not recognized if partitions are not unmounted
[[ "$BLANKEXTRA_ACTION" = "yes" ]] && blankextraspace
if [[ "${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}" = "$CURRENTSESSIONPARTITION" ]];then
	CHROOTCMD=""
	CHROOTUSR=""
else
	prepare_chroot
fi
dpkg_function
echo "SET@_label0.set_text('''$Reinstall_GRUB $GRUBSTAGEONE. $(eval_gettext $'This may require several minutes...')''')"
${CHROOTCMD}${GRUBTYPE_OF_PART[$PART_TO_REINSTALL_GRUB]} -v #Debug
[[ "${GRUBVER[$PART_TO_REINSTALL_GRUB]}" = "grub" ]] &&	ATA=""
if [[ "$(${CHROOTCMD}type grub-setup)" ]];then
	SETUPOUTPUT="$(LANGUAGE=C LC_ALL=C ${CHROOTCMD}grub-setup /dev/$GRUBSTAGEONE ; echo "SETUPEXIT:$?" )"
	echo "SETUPOUTPUT: $SETUPOUTPUT"
	if [[ "$SETUPOUTPUT" =~ FlexNet ]];then
		echo "FlexNet detected."
		blankextraspace
		SETUPOUTPUT="$(LANGUAGE=C LC_ALL=C ${CHROOTCMD}grub-setup /dev/$GRUBSTAGEONE ; echo "AFTERWIPE SETUPEXIT:$?" )"
		echo "AFTER WIPE: $SETUPOUTPUT"
	fi
fi
INSTALLOUTPUT="$(LANGUAGE=C LC_ALL=C ${CHROOTCMD}${GRUBTYPE_OF_PART[$PART_TO_REINSTALL_GRUB]} --recheck$ATA /dev/$GRUBSTAGEONE ; echo "INSTALLEXIT:$?" )"
echo "INSTALLOUTPUT: $INSTALLOUTPUT"
if [[ "$INSTALLOUTPUT" =~ "error: will not proceed with blocklists." ]] && [[ "$USE_SEPARATEBOOTPART" = "no" ]];then
	embeddingerror=yes
	end_of_pulsate
	zenity --error --title="$(eval_gettext "$CLEANNAME")" --text="GRUB embedding is not possible in $GRUBSTAGEONE. Please select a separate /boot partition. $Then_try_again"
	beginning_of_pulsate
else
	[[ "$UNCOMMENT_GFXMODE" = "yes" ]] && uncomment_gfxmode
	[[ "$ADD_KERNEL_OPTION" = "yes" ]] && add_kernel_option
	echo "SET@_label0.set_text('''Update GRUB. $(eval_gettext $'This may require several minutes...')''')"
	if [[ "${UPDATEGRUB_OF_PART[$PART_TO_REINSTALL_GRUB]}" = "update-grub" ]];then
		${CHROOTCMD}${UPDATEGRUB_OF_PART[$PART_TO_REINSTALL_GRUB]}
	elif [[ "${UPDATEGRUB_OF_PART[$PART_TO_REINSTALL_GRUB]}" =~ mkconfig ]];then
		for cfg in "/" "2/";do
			if [[ -d "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot/grub${cfg}" ]];then
				${CHROOTCMD}${UPDATEGRUB_OF_PART[$PART_TO_REINSTALL_GRUB]}${cfg}grub.cfg
			fi
		done
	fi
fi
unchroot_linux_to_reinstall
mount_all_blkid_partitions_except_df ; echo "[debug]Mount all the partitions for the logs"
}

blankextraspace() {
rm -f ${TMP_FOLDER_TO_BE_CLEARED}/sort
for partition in $(ls "/sys/block/${GRUBSTAGEONE}/" | grep "$GRUBSTAGEONE");do
	echo "$(cat "/sys/block/$GRUBSTAGEONE/${partition}/start" )" >> ${TMP_FOLDER_TO_BE_CLEARED}/sort
done
echo "63" >> ${TMP_FOLDER_TO_BE_CLEARED}/sort # Blank maximum 62 sectors (in case the first partition is far)
a=$(cat "${TMP_FOLDER_TO_BE_CLEARED}/sort" | sort -g -r | tail -1 )  #sort the file in the increasing order
[[ "$(grep "^[0-9]\+$" <<< $a )" ]] && SECTORS_TO_WIPE=$(($a-1)) || SECTORS_TO_WIPE="-1"
rm -f ${TMP_FOLDER_TO_BE_CLEARED}/sort
#  a=$(LANGUAGE=C LC_ALL=C fdisk -lu /dev/$disk | grep "sectors of"); b=${a##*= }; c=${b% *}; echo "$c" > /tmp/boot-sav_sort   #Other way to calculate
BYTES_PER_SECTOR="$(stat -c %B /dev/$GRUBSTAGEONE)"
echo "WIPE $GRUBSTAGEONE : ${SECTORS_TO_WIPE} sectors * ${BYTES_PER_SECTOR} bytes"
if [[ "$SECTORS_TO_WIPE" -gt "0" ]] && [[ "$SECTORS_TO_WIPE" -le "62" ]] && [[ "$BYTES_PER_SECTOR" -ge "512" ]] && [[ "$BYTES_PER_SECTOR" -le "1024" ]];then
	if [[ -d "$LOGREP/${GRUBSTAGEONE}" ]] && [[ ! -f "$LOGREP/${GRUBSTAGEONE}/before_wiping.img" ]];then
		dd if=/dev/$GRUBSTAGEONE of=$LOGREP/${GRUBSTAGEONE}/before_wiping.img bs=$BYTES_PER_SECTOR count=$SECTORS_TO_WIPE seek=1 #security
		dd if=/dev/zero of=/dev/$GRUBSTAGEONE bs=$BYTES_PER_SECTOR count=$SECTORS_TO_WIPE seek=1
	fi
else
	end_of_pulsate
	zenity --warning --title="$(eval_gettext "$CLEANNAME")" --text="By security, $GRUBSTAGEONE sectors were not wiped. \
	(one of these values is incorrect: SECTORS_TO_WIPE=$SECTORS_TO_WIPE , BYTES_PER_SECTOR=$BYTES_PER_SECTOR )"
	beginning_of_pulsate
fi
}

#####Used by repair, uninstaller (for GRUB reinstall, and purge)
force_unmount_os_partitions_in_mnt_except_reinstall_grub() {
echo "[debug]Unmount (force) all OS partitions except / and partition where we reinstall GRUB (${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]})"
echo "SET@_label0.set_text('''Unmount all except ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}. $(eval_gettext $'This may require several minutes...')''')"
pkill pcmanfm	#To avoid it automounts
for ((fuopimerg=1;fuopimerg<=TOTAL_QUANTITY_OF_OS;fuopimerg++)); do
	if [[ "${MNT_PATH[$fuopimerg]}" ]] && [[ "${OS_PARTITION[$fuopimerg]}" != "${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}" ]];then
		umount "${MNT_PATH[$fuopimerg]}"
	fi
done
}

#####Used by repair, uninstaller (for GRUB reinstall, and purge)
prepare_chroot() {
echo "SET@_label0.set_text('''Chroot. $(eval_gettext $'This may require several minutes...')''')"
for w in dev dev/pts proc sys; do mount -B /$w "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/$w" ; done  # /dev/pts ???
mount_separate_boot_if_required
CHROOTCMD="chroot ${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]} "
CHROOTUSR="chroot \"${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}\" "
#CHROOTCMD='chroot "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}" '
#CHROOTUSR='chroot \"${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}\" '
}

mount_separate_boot_if_required() {
if [[ "$USE_SEPARATEBOOTPART" = "yes" ]];then
	echo "[debug]mount_separate_boot_if_required ${BLKIDMNT_POINT[$BOOTPART_TO_USE]}"
	mkdir -p "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot"
	if [[ "$(ls "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot" )" ]];then
		echo "Warning: ${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot is not empty"
	else
		echo "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot is empty"
	fi
	pkill pcmanfm	#To avoid it automounts
	if [[ -d "${BLKIDMNT_POINT[$BOOTPART_TO_USE]}/boot" ]];then
		umount "${BLKIDMNT_POINT[$BOOTPART_TO_USE]}"
		mount "/dev/${LISTOFPARTITIONS[$BOOTPART_TO_USE]}/boot" "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot"
		echo "Mounted /dev/${LISTOFPARTITIONS[$BOOTPART_TO_USE]}/boot on ${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot"
	else
		umount "${BLKIDMNT_POINT[$BOOTPART_TO_USE]}"
		mount "/dev/${LISTOFPARTITIONS[$BOOTPART_TO_USE]}" "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot"
		echo "Mounted /dev/${LISTOFPARTITIONS[$BOOTPART_TO_USE]} on ${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot"		
	fi
fi
if [[ "$GRUBPACKAGE" = "grub-efi" ]];then
	echo "mount EFI boot ${BLKIDMNT_POINT[$EFIPART_TO_USE]}"
	if [[ ! -d "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot/efi/EFI" ]];then # or /efi/efi? https://wiki.archlinux.org/index.php/GRUB2#UEFI_systems
		mkdir -p "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot/efi/EFI"
		echo "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot/efi/EFI was created"
	fi
	pkill pcmanfm	#To avoid it automounts
	umount "${BLKIDMNT_POINT[$EFIPART_TO_USE]}"
	mount "/dev/${LISTOFPARTITIONS[$EFIPART_TO_USE]}" "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot/efi"
	echo "Mounted the EFI partition /dev/${LISTOFPARTITIONS[$EFIPART_TO_USE]} on ${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot/efi"
fi
}

unmount_separate_boot_if_required() {
if [[ "$USE_SEPARATEBOOTPART" = "yes" ]];then
	pkill pcmanfm	#To avoid it automounts
	umount "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot"
fi
if [[ "$GRUBPACKAGE" = "grub-efi" ]];then
	pkill pcmanfm	#To avoid it automounts
	umount "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot/efi"
fi
}

#####Used by repair, uninstaller (for GRUB reinstall, and purge)
unchroot_linux_to_reinstall() {
echo "SET@_label0.set_text('''Unchroot. $Please_wait''')"
unmount_separate_boot_if_required
pkill pcmanfm	#To avoid it automounts
if [[ "${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}" != "$CURRENTSESSIONPARTITION" ]];then
	for w in dev/pts dev proc sys; do umount "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/$w" ; done
fi
}


########################################### PURGE GRUB ##################################################################
purge_grub() {
echo "SET@_label0.set_text('''$Purge_and_reinstall_the_grub_of ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB_PURGE]}. $(eval_gettext $'This may require several minutes...')''')"
PART_TO_REINSTALL_GRUB="$PART_TO_REINSTALL_GRUB_PURGE"
echo "Purge the GRUB of ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB_PURGE]}"
force_unmount_os_partitions_in_mnt_except_reinstall_grub
echo "SET@_purgewindow.set_title('''$(eval_gettext "$CLEANNAME")''')"
echo "SET@_purgewindow.set_icon_from_file('''$APPNAME.png''')"
cp "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub" $LOGREP/${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}/grub_before_purge #Security
if [[ "${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}" = "$CURRENTSESSIONPARTITION" ]];then
	CHROOTCMD=""
	CHROOTUSR=""	
else
	prepare_chroot
	mv "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/resolv.conf" "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/resolv.conf.old"
	cp /etc/resolv.conf "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/resolv.conf"  # Required to connect to the Internet.
fi
repair_dep "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}"
dpkg_function
update_function
# Check if $GRUBPACKAGE (grub-efi or grub2) is available in the repositories
userok=""
testvalidsource $GRUBPACKAGE
if [[ ! "$VALIDSOURCE" ]] && [[ "$GRUBPACKAGE" = "grub2" ]];then
	testvalidsource grub-pc
	if [[ "$VALIDSOURCE" ]];then
		GRUBPACKAGE=grub-pc
	else
		testvalidsource grub
		if [[ "$VALIDSOURCE" ]];then
			GRUBPACKAGE=grub
			end_of_pulsate
			zenity --question --title="$(eval_gettext "$CLEANNAME")" --text="$This_will_install_an_obsolete_bootloader (GRUB Legacy). ${Do_you_want_to_continue}" || userok="no"
		fi
	fi
fi
# Pre-download the packages before purging them (security in case of internet failure just after purge)
if [[ "$GRUBPACKAGE" = "grub2" ]] || [[ "$GRUBPACKAGE" = "grub-pc" ]];then
	check_deb_install_feasibility "grub-gfxpayload-lists grub-pc grub-pc-bin grub2-common" "$PART_TO_REINSTALL_GRUB"
elif [[ "$GRUBPACKAGE" = "grub-efi" ]];then
	check_deb_install_feasibility "efibootmgr grub-efi-ia32 grub-efi-amd64 grub-efi-ia32-bin grub-efi-amd64-bin" "$PART_TO_REINSTALL_GRUB"
fi
if [[ ! "$userok" ]];then
	check_deb_install_feasibility "$GRUBPACKAGE grub-common ucf debconf" "$PART_TO_REINSTALL_GRUB"
fi
echo "DEBCHECK $DEBCHECK"
if [[ ! "$VALIDSOURCE" ]] || [[ "$DEBCHECK" = "debNG" ]] || [[ "$VALIDSOURCE" =~ none ]] || [[ "$userok" ]];then
	restore_dep "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}"
	end_of_pulsate
	if [[ ! "$VALIDSOURCE" ]] || [[ "$VALIDSOURCE" =~ none ]];then
		if [[ -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/apt/sources.list" ]];then
			echo "No valid source for $GRUBPACKAGE"
			xdg-open "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/apt/sources.list" &
		else
			echo "No ${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/apt/sources.list"
		fi
		PACKAGELIST="${GRUBPACKAGE}"; DISTRO="${OSNAME[$PART_TO_REINSTALL_GRUB]} (${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]})"; update_translations
		zenity --info --title="$(eval_gettext "$CLEANNAME")" --text="$Please_enable_a_rep_for_PACKAGELIST_pack_in_DISTRO ${Then_try_again}"
	else
		zenity --info --title="$(eval_gettext "$CLEANNAME")" --text="${Please_close_all_your_package_managers} (${Software_Centre}, \
		${Update_Manager}, Synaptic, ...). ${Then_try_again}"
	fi
	echo 'SET@_mainwindow.show()'
else
	if [[ -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/usr/sbin/grub-install" ]] \
	|| [[ -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/sbin/grub2-install" ]] \
	|| [[ -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/usr/sbin/grub2-install" ]] \
	|| [[ "${BOOTPRESENCE_OF_PART[$PART_TO_REINSTALL_GRUB]}" = "no boot" ]];then
		PACKSTOPURGE="grub-common"
		COMMAND="${APTTYP[$PART_TO_REINSTALL_GRUB]} ${PURGETYP[$PART_TO_REINSTALL_GRUB]} ${YESTYP[$PART_TO_REINSTALL_GRUB]}"
		if [[ "${APTTYP[$PART_TO_REINSTALL_GRUB]}" = "apt-get" ]];then
			echo "SET@_label8.set_text('''$Please_open_a_terminal_then_type_the_following_command''')"
			${CHROOTCMD}${GRUBTYPE_OF_PART[$PART_TO_REINSTALL_GRUB]} -v #Debug
			echo "SET@_label9.set_text('''sudo ${CHROOTUSR}$COMMAND $PACKSTOPURGE''')"
			echo "SET@_label10.set_text('''\\n${Then_choose_Yes_when_the_below_window_appears}\\n''')"
		else
			for pack in $PACKSTOPURGE grub2 grub grub-pc grub-efi grub2-common;do	
				${CHROOTCMD}$COMMAND $pack
			done
			then_type_this_purge_command
		fi
	else  # GRUB already missing
		then_type_this_purge_command
	fi
	if [[ "${APTTYP[$PART_TO_REINSTALL_GRUB]}" = "apt-get" ]];then
		end_of_pulsate
		echo 'SET@_purgewindow.show()'
	else
		check_part_types #update variables
		purge_end
	fi
fi
}

testvalidsource() {
PACKTOVALIDATE=$1
temp="$(LANGUAGE=C LC_ALL=C ${CHROOTCMD}${POLICYTYP[$PART_TO_REINSTALL_GRUB]} $PACKTOVALIDATE )"
VALIDSOURCE="$(${CANDIDATETYP[$PART_TO_REINSTALL_GRUB]} <<< $temp )"
[[ "${CANDIDATETYP2[$PART_TO_REINSTALL_GRUB]}" ]] && VALIDSOURCE="$(${CANDIDATETYP2[$PART_TO_REINSTALL_GRUB]} <<< $temp )"
}

## Called by purge_grub and _button8
then_type_this_purge_command() {
COMMAND="${APTTYP[$PART_TO_REINSTALL_GRUB]} ${INSTALLTYP[$PART_TO_REINSTALL_GRUB]} ${YESTYP[$PART_TO_REINSTALL_GRUB]} $GRUBPACKAGE"
if [[ "${APTTYP[$PART_TO_REINSTALL_GRUB]}" = "apt-get" ]];then
	rm -rf "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot/grub"
	rm -rf "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/boot/grub2" 
	#If the user had modified something manually the folder would have remained.
	rm -rf "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/grub.d/proxifiedScripts/linux" #Solves Grub-Customizer bug887761
	echo "SET@_label8.set_text('''$Now_please_type_this_command_in_the_terminal''')"
	echo "SET@_label9.set_text('''sudo ${CHROOTUSR}$COMMAND''')"
	echo "SET@_label10.set_text('''\\n${Then_select_correct_device_when_the_below_window_appears}\\n''')"
	echo 'SET@_hbox9.hide()'; echo 'SET@_hbox10.show()'
	echo 'SET@_button6.hide()'; echo 'SET@_button8.hide()'; echo 'SET@_button7.show()';echo 'SET@_button9.show()';
else
	${CHROOTCMD}$COMMAND os-prober
fi
}

check_deb_install_feasibility() {
#$1:DEBs $2:part
DEBCHECK="debOK"
if [[ "${APTTYP[$2]}" = "apt-get" ]];then
	if [[ "${LISTOFPARTITIONS[$2]}" = "$CURRENTSESSIONPARTITION" ]];then
		for DEBTOCHECK in $1;do
			rm -f /var/cache/apt/archives/${DEBTOCHECK}_*
			${APTTYP[$2]} -d ${YESTYP[$2]} install --reinstall $DEBTOCHECK || DEBCHECK="debNG" #internet KO or dpkg blocked (e.g. Synaptic is open)
		done
	else
		for w in dev dev/pts proc sys; do mount -B /$w "${BLKIDMNT_POINT[$2]}/$w"; done
		for DEBTOCHECK in $1;do
			rm -f ${BLKIDMNT_POINT[$2]}/var/cache/apt/archives/${DEBTOCHECK}_*
			chroot "${BLKIDMNT_POINT[$2]}" ${APTTYP[$2]} -d ${YESTYP[$2]} install --reinstall $DEBTOCHECK || DEBCHECK="debNG"
		done
		for w in dev/pts dev proc sys; do umount "${BLKIDMNT_POINT[$2]}/$w"; done
	fi
	echo "DEBCHECK $DEBCHECK, $1, ${LISTOFPARTITIONS[$2]}"
fi
}

#First cancel button of Purge GRUB process
_button6() {
quit_purge
zenity --info --title="$(eval_gettext "$CLEANNAME")" --text="$No_change_have_been_performed_on_your_computer_See_you_soon"
echo 'EXIT@@'
}

#Second cancel button of Purge GRUB process
_button7() {
quit_purge
zenity --warning --text="${GRUB_reinstallation_has_been_cancelled}\\n ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]} ${is_now_without_GRUB}"
echo 'EXIT@@'
}

#Called by cancel buttons of Purge GRUB process
quit_purge() {
echo "SET@pulsatewindow.set_title('''${Scanning_systems}''')"; 
echo 'SET@_purgewindow.hide()'
beginning_of_pulsate
restore_dep "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}"
echo "GRUB reinstallation not performed by the user after Purge : the system will remain without any GRUB"
sleep 10 # In case an operation in the user terminal was not finished
restore_resolvconf_and_unchroot
mount_all_blkid_partitions_except_df ; echo "[debug]Mount all the partitions for the logs"
save_log_on_disks ; unmount_all_blkid_partitions_except_df; 
end_of_pulsate; 
}

#Called by purge GRUB
restore_resolvconf_and_unchroot() {
if [[ "${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}" != "$CURRENTSESSIONPARTITION" ]];then
	rm "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/resolv.conf"
	mv "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/resolv.conf.old" "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/resolv.conf"
	unchroot_linux_to_reinstall
fi
}

#Called by purge GRUB
_button8() {
check_internet_connection
if [[ "$INTERNET" = "no-internet" ]];then # In case connexion is cut after instructions
	echo "SET@_label11.set_text('''${No_internet_connection_detected}''')"
	echo 'SET@_label11.show()'; sleep 2; echo 'SET@_label11.hide()'
elif [[ -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/usr/sbin/grub-install" ]] || [[ -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/sbin/grub2-install" ]];then
	echo "SET@_label11.set_text('''\\n${GRUB_is_still_present} ${Please_try_again}''')"
	echo 'SET@_label11.show()'; sleep 3; echo 'SET@_label11.hide()'
else
	then_type_this_purge_command
fi
}

#Called by purge GRUB
_button9() {
check_internet_connection
if [[ ! -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/usr/sbin/grub-install" ]] && [[ ! -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/sbin/grub2-install" ]];then
	echo "SET@_label11.set_text('''\\n${GRUB_is_still_absent} ${Please_try_again}''')"
	echo 'SET@_label11.show()'; sleep 2; echo 'SET@_label11.hide()'
else
	echo 'SET@_purgewindow.hide()'
	beginning_of_pulsate
	sleep 20 # To avoid unmounting before the update is finished
	purge_end
fi
}

purge_end() {
if [[ "$UNCOMMENT_GFXMODE" = "yes" ]] || [[ "$ADD_KERNEL_OPTION" = "yes" ]];then
	[[ "$UNCOMMENT_GFXMODE" = "yes" ]] && uncomment_gfxmode
	[[ "$ADD_KERNEL_OPTION" = "yes" ]] && add_kernel_option
	[[ "$UNHIDEBOOT_ACTION" = "yes" ]] && unhide_boot_menus_etc_default_grub	#Because a new GRUB has been generated
	${CHROOTCMD}${GRUBTYPE_OF_PART[$PART_TO_REINSTALL_GRUB]} -v #Debug
fi
restore_dep "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}"
restore_resolvconf_and_unchroot
reinstall_action
mount_all_blkid_partitions_except_df ; echo "[debug]Force mount all OS partitions for the logs"
if [[ "$embeddingerror" ]];then
	save_log_on_disks
	end_of_pulsate
	echo 'SET@_mainwindow.show()'
else
	unmount_all_and_success_repair
fi
}

################################ UPDATE PACKAGES ACTION (USED BY PURGE_GRUB) ###################################
update_function() {
check_internet_connection
if [[ "$INTERNET" = "connected" ]];then
	${CHROOTCMD}${APTTYP[$PART_TO_REINSTALL_GRUB]} ${UPDATETYP[$PART_TO_REINSTALL_GRUB]}
	[[ "${UPDATETYP2[$PART_TO_REINSTALL_GRUB]}" ]] && ${CHROOTCMD}${UPDATETYP2[$PART_TO_REINSTALL_GRUB]}
else
	display_error_and_back_to_mainwindow
fi
###### Repair packages #######
#  check_internet_connection
#  if [[ "$INTERNET" = "connected" ]];then
#      ${CHROOTCMD}${APTTYP[$PART_TO_REINSTALL_GRUB]} install -fy
#  else
#    display_error_and_back_to_mainwindow
#  fi
}

display_error_and_back_to_mainwindow() {
restore_resolvconf_and_unchroot
end_of_pulsate
zenity --error --title="$(eval_gettext "$CLEANNAME")" --text="$No_internet_connection_detected"
echo 'SET@_mainwindow.show()'
}


########################################### UNCOMMENT GFXMODE ############################
uncomment_gfxmode() {
echo "UNCOMMENT_GFXMODE of ${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub"
echo "SET@_label0.set_text('''$Uncomment_GRUB_GFXMODE. $(eval_gettext $'This may require several minutes...')''')"
if [[ -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub" ]];then
	rm -f $TMP_FOLDER_TO_BE_CLEARED/grub_new
	while read line; do
		if [[ "$line" =~ "#GRUB_GFXMODE=" ]];then
			echo "${line#*#}" >> $TMP_FOLDER_TO_BE_CLEARED/grub_new
		else
			echo "$line" >> $TMP_FOLDER_TO_BE_CLEARED/grub_new
		fi
	done < <(echo "$(< "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub" )")
	cp -f "$TMP_FOLDER_TO_BE_CLEARED/grub_new" "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub"
	echo "Uncommented GFX_MODE in ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}/etc/default/grub"
fi
}

########################################### ADD KERNEL ############################
add_kernel_option() {
echo "add_kernel_option CHOSEN_KERNEL_OPTION is : $CHOSEN_KERNEL_OPTION"
echo "SET@_label0.set_text('''$Add_a_kernel_option $CHOSEN_KERNEL_OPTION. $(eval_gettext $'This may require several minutes...')''')"
if [[ -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub" ]];then
	rm -f $TMP_FOLDER_TO_BE_CLEARED/grub_new
	while read line; do
		if [[ "$line" =~ "GRUB_CMDLINE_LINUX_DEFAULT=" ]];then
			echo "${line%\"*} ${CHOSEN_KERNEL_OPTION}\"" >> $TMP_FOLDER_TO_BE_CLEARED/grub_new
		else
			echo "$line" >> $TMP_FOLDER_TO_BE_CLEARED/grub_new
		fi
	done < <(echo "$(< "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub" )")
	cp -f $TMP_FOLDER_TO_BE_CLEARED/grub_new "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub"
	echo "Added kernel options in ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}/etc/default/grub"
fi
}

########################################### DPKG FUNCTION ############################
dpkg_function() {
if [[ -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/usr/bin/dpkg" ]];then
	echo "dpkg --configure -a ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}" #Used by reinstall and purge GRUB
	echo "SET@_label0.set_text('''dpkg --configure -a ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}. $(eval_gettext $'This may require several minutes...')''')"
	${CHROOTCMD}dpkg --configure -a
fi
}

########################################### OPEN etc/default/grub ############################
_button_open_etc_default_grub() {
if [[ -f "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub" ]];then
	xdg-open "${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub" &
else
	echo "User tried to open ${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub but it does not exist."
	zenity --info --title="$(eval_gettext "$CLEANNAME")" --text="${BLKIDMNT_POINT[$PART_TO_REINSTALL_GRUB]}/etc/default/grub does not exist. Please choose the [Purge and reinstall] option."
fi
}

########################################### UNHIDE BOOT MENUS ############################
unhide_boot_menus_xp() {
echo "[debug]Unhide boot menu (${UNHIDEBOOT_TIME} seconds) if Wubi detected"
if [[ "$QTY_WUBI" != "0" ]];then
	for ((i=1;i<=NBOFPARTITIONS;i++)); do
		if [[ -f "${BLKIDMNT_POINT[$i]}/boot.ini" ]];then
			echo "SET@_label0.set_text('''$Unhide_boot_menu. $(eval_gettext $'This may require several minutes...')''')"
			cp "${BLKIDMNT_POINT[$i]}/boot.ini" "$LOGREP/${LISTOFPARTITIONS[$i]}/boot.ini_old"
			cp "${BLKIDMNT_POINT[$i]}/boot.ini" "$LOGREP/${LISTOFPARTITIONS[$i]}/boot.ini_new"
			MODIFDONE=""
			for line in $(cat "${BLKIDMNT_POINT[$i]}/boot.ini"); do #No " around cat
				if [[ "$line" =~ "timeout=" ]] && [[ "$line" != "timeout=${UNHIDEBOOT_TIME}" ]];then
					sed -i "s/${line}.*/timeout=${UNHIDEBOOT_TIME}/" "$LOGREP/${LISTOFPARTITIONS[$i]}/boot.ini_new"
					MODIFDONE="yes"
				fi
			done
			if [[ -f "$LOGREP/${LISTOFPARTITIONS[$i]}/boot.ini_new" ]] && [[ "$MODIFDONE" = "yes" ]];then #Security
				echo "Unhide Windows XP boot menu in ${LISTOFPARTITIONS[$i]}/boot.ini"
				mv "$LOGREP/${LISTOFPARTITIONS[$i]}/boot.ini_new" "${BLKIDMNT_POINT[$i]}/boot.ini"
			elif [[ ! -f "$LOGREP/${LISTOFPARTITIONS[$i]}/boot.ini_new" ]];then
				echo "Error: could not unhide XP in ${LISTOFPARTITIONS[$i]}/boot.ini"
				zenity --error --text="Error: could not unhide XP in ${LISTOFPARTITIONS[$i]}/boot.ini"
			else
				rm "$LOGREP/${LISTOFPARTITIONS[$i]}/boot.ini_old"
				rm "$LOGREP/${LISTOFPARTITIONS[$i]}/boot.ini_new"
			fi
		fi
	done
fi
}

unhide_boot_menus_etc_default_grub() {
for ((i=1;i<=NBOFPARTITIONS;i++)); do
	if [[ -f "${BLKIDMNT_POINT[$i]}/etc/default/grub" ]];then
		echo "SET@_label0.set_text('''$Unhide_boot_menu. $(eval_gettext $'This may require several minutes...')''')"
		cp "${BLKIDMNT_POINT[$i]}/etc/default/grub" "$LOGREP/${LISTOFPARTITIONS[$i]}/etc_default_grub_old"
		cp "${BLKIDMNT_POINT[$i]}/etc/default/grub" "$LOGREP/${LISTOFPARTITIONS[$i]}/etc_default_grub_new"
		MODIFDONE=""
		for line in $(cat "${BLKIDMNT_POINT[$i]}/etc/default/grub"); do
			if [[ "$line" =~ "GRUB_TIMEOUT=" ]] && [[ "$line" != "GRUB_TIMEOUT=${UNHIDEBOOT_TIME}" ]];then
				sed -i "s/${line}.*/GRUB_TIMEOUT=${UNHIDEBOOT_TIME}/" "$LOGREP/${LISTOFPARTITIONS[$i]}/etc_default_grub_new"
				MODIFDONE="yes" #Set timout to UNHIDEBOOT_TIME seconds
			elif [[ "$line" =~ "GRUB_HIDDEN_TIMEOUT=" ]] && [[ ! "$line" =~ "#GRUB_HIDDEN_TIMEOUT=" ]];then
				sed -i "s/${line}.*/#${line}/" "$LOGREP/${LISTOFPARTITIONS[$i]}/etc_default_grub_new"
				MODIFDONE="yes" #Comment GRUB_HIDDEN_TIMEOUT
			elif [[ "$line" =~ "GRUB_DISABLE_RECOVERY=" ]] && [[ ! "$line" =~ "#GRUB_DISABLE_RECOVERY=" ]];then
				sed -i "s/${line}.*/#${line}/" "$LOGREP/${LISTOFPARTITIONS[$i]}/etc_default_grub_new"
				MODIFDONE="yes" #Comment GRUB_DISABLE_RECOVERY
			fi
		done
		if [[ -f "$LOGREP/${LISTOFPARTITIONS[$i]}/etc_default_grub_new" ]] && [[ "$MODIFDONE" = "yes" ]];then #Security
			echo "Unhide GRUB boot menu in ${LISTOFPARTITIONS[$i]}/etc/default/grub"
			mv "$LOGREP/${LISTOFPARTITIONS[$i]}/etc_default_grub_new" "${BLKIDMNT_POINT[$i]}/etc/default/grub"
		elif [[ ! -f "$LOGREP/${LISTOFPARTITIONS[$i]}/etc_default_grub_new" ]];then
			echo "Error: could not unhide GRUB menu in ${LISTOFPARTITIONS[$i]}/etc/default/grub"
			zenity --error --text="Error: could not unhide GRUB menu in ${LISTOFPARTITIONS[$i]}/etc/default/grub"
		else
			rm "$LOGREP/${LISTOFPARTITIONS[$i]}/etc_default_grub_old"
			rm "$LOGREP/${LISTOFPARTITIONS[$i]}/etc_default_grub_new"
		fi
	fi
done
}

unhide_boot_menus_grubcfg() {
for ((i=1;i<=NBOFPARTITIONS;i++)); do
	for FLD in grub grub2;do
		if [[ -f "${BLKIDMNT_POINT[$i]}/boot/${FLD}/grub.cfg" ]];then
			echo "SET@_label0.set_text('''$Unhide_boot_menu. $(eval_gettext $'This may require several minutes...')''')"
			cp "${BLKIDMNT_POINT[$i]}/boot/${FLD}/grub.cfg" "$LOGREP/${LISTOFPARTITIONS[$i]}/grub.cfg_old"
			cp "${BLKIDMNT_POINT[$i]}/boot/${FLD}/grub.cfg" "$LOGREP/${LISTOFPARTITIONS[$i]}/grub.cfg_new"
			MODIFDONE=""
			for line in $(cat "${BLKIDMNT_POINT[$i]}/boot/${FLD}/grub.cfg"); do
				if [[ "$line" =~ "timeout=" ]] && [[ "$line" != "timeout=${UNHIDEBOOT_TIME}" ]];then
					sed -i "s/${line}.*/timeout=${UNHIDEBOOT_TIME}/" "$LOGREP/${LISTOFPARTITIONS[$i]}/grub.cfg_new"
					MODIFDONE="yes" #Set timout to UNHIDEBOOT_TIME seconds
				fi
			done
			if [[ -f "$LOGREP/${LISTOFPARTITIONS[$i]}/grub.cfg_new" ]] && [[ "$MODIFDONE" = "yes" ]];then #Security
				echo "Unhide GRUB boot menu in ${LISTOFPARTITIONS[$i]}/boot/${FLD}/grub.cfg"
				mv "$LOGREP/${LISTOFPARTITIONS[$i]}/grub.cfg_new" "${BLKIDMNT_POINT[$i]}/boot/${FLD}/grub.cfg"
				[[ "$i" = "$PART_TO_REINSTALL_GRUB" ]] && rm "$LOGREP/${LISTOFPARTITIONS[$i]}/grub.cfg_old" #Not needed
			elif [[ ! -f "$LOGREP/${LISTOFPARTITIONS[$i]}/grub.cfg_new" ]];then
				echo "Error: could not unhide GRUB menu in ${LISTOFPARTITIONS[$i]}/boot/${FLD}/grub.cfg"
				zenity --error --text="Error: could not unhide GRUB menu in ${LISTOFPARTITIONS[$i]}/boot/${FLD}/grub.cfg"
			else
				rm "$LOGREP/${LISTOFPARTITIONS[$i]}/grub.cfg_old"
				rm "$LOGREP/${LISTOFPARTITIONS[$i]}/grub.cfg_new"
			fi
		fi
	done
done
}

######################### USE STATS FOR IMPROVING THE TOOLS##################
stats() {
URLST="http://sourceforge.net/projects/$APPNAME/files/statistics/boot-repair"
CODO="counter/download"
WGETST="wget -o /dev/null -O"
for ((i=1;i<=TOTAL_QUANTITY_OF_OS;i++)); do
	[[ -f "${LOG_PATH[$i]}/$APPNAME" ]] && NEWUSER="no" || touch "${LOG_PATH[$i]}/$APPNAME"
done
[[ ! "$NEWUSER" ]] && $WGETST ${TMP_FOLDER_TO_BE_CLEARED}/nu $URLST.user.$CODO
}

######################### BOOTFLAG #################################
bootflag_action() {
#called by bootrepairactions and restore_mbr
PARTTOBEFLAGGED=$1
temp=${LISTOFPARTITIONS[$PARTTOBEFLAGGED]}	#sdXY
PRIMARYNUM="${temp##*[a-z]}"				#Y (1~4) of sdXY
DISKTOFLAG="${DISK_PART[$PARTTOBEFLAGGED]}" #sdX
echo "bootflag_action $temp (=${DISKTOFLAG}${PRIMARYNUM})"
for ((a=1;a<=4;a++)); do
	if [[ "$a" != "$PRIMARYNUM" ]];then
		echo "parted /dev/$DISKTOFLAG set $a boot off"
		parted /dev/$DISKTOFLAG set $a boot off	
	fi
done
echo "parted /dev/$DISKTOFLAG set $PRIMARYNUM boot on"
parted /dev/$DISKTOFLAG set $PRIMARYNUM boot on
}

##################### REPAIR BOOT INI ################################
repair_boot_ini() {
echo "[debug]repair_boot_ini (solves bug#923374)"
for ((i=1;i<=NBOFPARTITIONS;i++)); do
	if [[ -f "${BLKIDMNT_POINT[$i]}/ntldr" ]] || [[ -f "${BLKIDMNT_POINT[$i]}/NTDETECT.COM" ]];then
		temp=${LISTOFPARTITIONS[$i]}	#sdXY
		tempnum="${temp##*[a-z]}"					#Y of sdXY
		templetter=$(cut -c3 <<< ${DISK_PART[$i]} )	#X of sdXY
		tempdisk=0
		for letter in a b c d;do
			[[ "$templetter" = "$letter" ]] && break || ((tempdisk += 1 ))
		done
		tempfld="${BLKIDMNT_POINT[$i]}/boot.ini"
		if [[ ! -f "$tempfld" ]];then
			echo "[boot loader]
timeout=${UNHIDEBOOT_TIME}
default=multi(0)disk(0)rdisk(${tempdisk})partition(${tempnum})\WINDOWS
[operating systems]
multi(0)disk(0)rdisk(${tempdisk})partition(${tempnum})\WINDOWS="Windows" /noexecute=optin /fastdetect" > "$tempfld"
			echo "Regenerated $tempfld"
		elif [[ ! "$(cat "$tempfld" | grep "on(${tempnum})" )" ]];then
			sed -i.bak "s|on([0-9])|on(${tempnum})|g" "$tempfld"
			echo "Repaired $tempfld"
		elif [[ -f "${tempfld}.bak" ]];then
			echo "Detected ${tempfld}.bak"
		fi
	fi
done
}
